//Comments on readability, niceness of the solution, efficiency if possible.
#ifndef BOARD_H
#define BOARD_H

#include <QObject>
#include <QList>
#include "Tile.h"

class Board : public QObject
{
    //QVector http://qt-project.org/doc/qt-4.8/qvector.html
    //QList http://qt-project.org/doc/qt-4.8/qlist.html
    Q_OBJECT
private:
    QList<Tile> _tiles;

    int _sideLength;



public:
    QList<Tile> getTiles()
    {
        return _tiles;
    }

    int getSideLength()
    {
        return _sideLength;
    }

    explicit Board(QObject *parent = 0);
    explicit Board(int sideLength, QString letters);

    //Copy constructor. Might not need a copy constructor as we may not be going multithreaded to preserve operating memory.
    Board(const Board& originalBoard);

    /**
     * TODO: Convert to properties
     */

    Tile* getTileAt(int x, int y);

    void Print();
};

#endif // BOARD_H
